#include <smtpd/mail.hpp>
#include <smtpd/types.hpp>
#include <smtpd/token.hpp>

#include <any>
#include <functional>

namespace smtpd {
    class Request {
    public:
        void proceed();
        void junk();
        void fail(std::string response = "451 Aborted");
        void commit();

        void sendFilterResult(TokenPattern pattern);
        void submitMail(const Mail & mail);

        std::any payload;

        std::function<void(Token command, TokenPattern arguments)> send;

    private:
        void submitMailSection(const std::vector<std::string> & lines, bool isBody);
        void submitDataLine(std::string line, bool inBody);
    };
}
